## sep 1.2.1

=== Makefile ===

OS ?= $(shell sh -c 'uname -s | tr "[A-Z]" "[a-z]"')

SOMAJOR = 1
SOMINOR = 0
SOBUGFIX = 3

ifeq ($(OS), darwin)
SONAME = libsep.dylib
SONAME_MAJOR = libsep.$(SOMAJOR).dylib
SONAME_FULL = libsep.$(SOMAJOR).$(SOMINOR).$(SOBUGFIX).dylib
SONAME_FLAG = -install_name
LDPATHENV = DYLD_LIBRARY_PATH
else
ifeq ($(OS), linux)
SONAME = libsep.so
SONAME_MAJOR = libsep.so.$(SOMAJOR)
SONAME_FULL = libsep.so.$(SOMAJOR).$(SOMINOR).$(SOBUGFIX)
SONAME_FLAG = -soname
LDPATHENV = LD_LIBRARY_PATH
else
$(error OS not yet supported)
endif
endif

INSTALL ?= install
DESTDIR =
PREFIX ?= /usr/local
LIBDIR = $(PREFIX)/lib
INCLUDEDIR = $(PREFIX)/include

CC?=gcc
AR?=ar
CPPFLAGS ?=
LDFLAGS ?=

CPPFLAGS += -Isrc
CFLAGS += -Wall -Wextra -Wcast-qual -O3 -fvisibility=hidden  # -Werror
CFLAGS_LIB = $(CFLAGS) -fPIC
LDFLAGS_LIB = $(LDFLAGS) -shared -Wl,$(SONAME_FLAG),$(SONAME_MAJOR)

OBJS = src/analyse.o src/convolve.o src/deblend.o src/extract.o \
       src/lutz.o src/aperture.o src/background.o src/util.o

default: all

src/analyse.o src/convolve.o src/deblend.o src/extract.o src/lutz.o: src/%.o: src/%.c src/extract.h src/sepcore.h src/sep.h
	$(CC) $(CPPFLAGS) $(CFLAGS_LIB) -c src/$*.c -o $@

src/aperture.o: src/aperture.c src/aperture.i src/overlap.h src/sepcore.h src/sep.h
	$(CC) $(CPPFLAGS) $(CFLAGS_LIB) -c src/aperture.c -o $@

src/background.o src/util.o: src/%.o: src/%.c src/sepcore.h src/sep.h
	$(CC) $(CPPFLAGS) $(CFLAGS_LIB) -c src/$*.c -o $@

src/$(SONAME_FULL) src/$(SONAME_MAJOR) src/$(SONAME) &: $(OBJS)
	$(CC) $(LDFLAGS_LIB) $^ -lm -o src/$(SONAME_FULL)
	ln -sf $(SONAME_FULL) src/$(SONAME_MAJOR)
	ln -sf $(SONAME_FULL) src/$(SONAME)

src/libsep.a: $(OBJS)
	$(AR) rcs src/libsep.a $^

install: all
	$(INSTALL) -d $(DESTDIR)$(INCLUDEDIR)
	$(INSTALL) -m u=rw,g=r,o=r src/sep.h $(DESTDIR)$(INCLUDEDIR)

	$(INSTALL) -d $(DESTDIR)$(LIBDIR)
	$(INSTALL) -m u=rwx,g=rx,o=rx src/$(SONAME_FULL) $(DESTDIR)$(LIBDIR)
	ln -sf $(SONAME_FULL) $(DESTDIR)$(LIBDIR)/$(SONAME_MAJOR)
	ln -sf $(SONAME_FULL) $(DESTDIR)$(LIBDIR)/$(SONAME)
	$(INSTALL)  -m u=rw,g=r,o=r src/libsep.a $(DESTDIR)$(LIBDIR)

uninstall:
	rm $(DESTDIR)$(INCLUDEDIR)/sep.h
	rm $(DESTDIR)$(LIBDIR)/$(SONAME_FULL)
	rm $(DESTDIR)$(LIBDIR)/$(SONAME_MAJOR)
	rm $(DESTDIR)$(LIBDIR)/$(SONAME)
	rm $(DESTDIR)$(LIBDIR)/libsep.a

test: ctest/test_image
	$(LDPATHENV)=src ctest/test_image data/image.fits data/sep.cat
	ctest/compare.py data/image.cat data/sep.cat

ctest/test_image: ctest/test_image.c src/$(SONAME)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -Lsrc ctest/test_image.c -lm -lsep -o ctest/test_image

clean:
	rm -f src/*.o src/*.a src/libsep.* ctest/test_image

all: src/$(SONAME_FULL) src/libsep.a

.PHONY: all test clean library install uninstall

=== debian/changelog ===
sep (1.2.1-7) unstable; urgency=medium

  * Add 'd/clean' and add missing elements. (Closes: #1049013)
  * 'd/control':
    - Add myself to 'Uploaders'.
    - Update 'Standards-Version' to 4.7.0, no changes required.
  * 'd/rules': Add hardening 'all'.
  * 'd/watch': Drop problematic 'debian uupdate'.

 -- Phil Wyett <philip.wyett@kathenas.org>  Thu, 10 Oct 2024 08:21:22 +0100

sep (1.2.1-6) unstable; urgency=medium

  * Use CURDIR instead of PWD to get current dir

 -- Ole Streicher <olebole@debian.org>  Fri, 12 Aug 2022 20:51:16 +0200

sep (1.2.1-5) unstable; urgency=medium

  * Replace BUILD_ROOT usage by creating the complete path in d/rules

 -- Ole Streicher <olebole@debian.org>  Fri, 12 Aug 2022 08:19:32 +0200

sep (1.2.1-4) unstable; urgency=medium

  * Use shell command to extract build root

 -- Ole Streicher <olebole@debian.org>  Thu, 11 Aug 2022 21:10:36 +0200

sep (1.2.1-3) unstable; urgency=medium

  * Make estimation of pwd in d/rules more robust

 -- Ole Streicher <olebole@debian.org>  Thu, 11 Aug 2022 20:16:01 +0200

sep (1.2.1-2) unstable; urgency=medium

  * Add ASCL-Id to metadata

 -- Ole Streicher <olebole@debian.org>  Thu, 11 Aug 2022 15:07:38 +0200

sep (1.2.1-1) unstable; urgency=medium

  * Initial release. (Closes: #941158)

 -- Ole Streicher <olebole@debian.org>  Sat, 06 Aug 2022 11:34:03 +0200

=== debian/control ===
Source: sep
Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Ole Streicher <olebole@debian.org>,
           Phil Wyett <philip.wyett@kathenas.org>
Section: python
Priority: optional
Build-Depends: cmake,
               cython3,
               debhelper-compat (= 13),
               dh-python,
               python3-all-dev,
               python3-astropy <!nocheck>,
               python3-numpy,
               python3-pytest <!nocheck>,
               python3-setuptools
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian-astro-team/sep
Vcs-Git: https://salsa.debian.org/debian-astro-team/sep.git
Homepage: https://github.com/kbarbary/sep
Rules-Requires-Root: no

Package: libsep0
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends}
Multi-Arch: same
Description: C library for source extraction and photometry
 SEP makes the core algorithms of Source Extractor available as a
 library of stand-alone functions and classes. These operate
 directly on in-memory arrays (no FITS files or configuration files).
 The code is derived from the Source Extractor code base (written in
 C) and aims to produce results compatible with Source Extractor
 whenever possible.
 .
 This package contains the shared library.

Package: libsep-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsep0 (= ${binary:Version})
Description: C library for source extraction and photometry (development files)
 SEP makes the core algorithms of Source Extractor available as a
 library of stand-alone functions and classes. These operate
 directly on in-memory arrays (no FITS files or configuration files).
 The code is derived from the Source Extractor code base (written in
 C) and aims to produce results compatible with Source Extractor
 whenever possible.

Package: python3-sep
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         libsep0 (= ${binary:Version})
Description: Python library for source extraction and photometry
 SEP makes the core algorithms of Source Extractor available as a
 library of stand-alone functions and classes. These operate
 directly on in-memory arrays (no FITS files or configuration files).
 The code is derived from the Source Extractor code base (written in
 C) and aims to produce results compatible with Source Extractor
 whenever possible.
 .
 This Python module that wraps the C library in a Pythonic API. The
 Python wrapper operates on NumPy arrays.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export PYBUILD_NAME=sep
export PYBUILD_SYSTEM=distutils
export SEP_LIB_PATH=$(CURDIR)/obj-$(DEB_TARGET_GNU_TYPE)

PY3VERS ?= $(shell py3versions -vr)

%:
	dh $@ --with python3

override_dh_auto_clean:
	dh_auto_clean -O--buildsystem=cmake
	dh_auto_clean -O--buildsystem=pybuild

override_dh_auto_configure:
	dh_auto_configure -O--buildsystem=cmake
	dh_auto_configure -O--buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build -O--buildsystem=cmake
	dh_auto_build -O--buildsystem=pybuild

override_dh_auto_install:
	dh_auto_install -O--buildsystem=cmake
	dh_auto_install -O--buildsystem=pybuild

override_dh_auto_test:
	for py in $(PY3VERS); do \
	  PYTHONPATH=.pybuild/cpython3_$${py}_sep/build \
	  LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_TARGET_GNU_TYPE) \
	  python$${py} -m pytest test.py; \
	done

execute_after_dh_install:
	dh_numpy3

## sep 1.4.0

=== debian/changelog ===
sep (1.4.0-1) unstable; urgency=medium

  * New upstream version 1.4.0
  * Drop Numpy-2.2-compatibility.patch, applied upstream
  * Update d/clean
  * New build dependency python3-setuptools-scm
  * Ensure dh_numpy3 is run

 -- Ole Streicher <olebole@debian.org>  Fri, 07 Feb 2025 09:35:41 +0100

sep (1.2.1-8) unstable; urgency=medium

  * Numpy 2.2 compatibility (Closes: #1094758)

 -- Ole Streicher <olebole@debian.org>  Fri, 31 Jan 2025 14:20:56 +0100

=== debian/control ===
--- 
+++ 
@@ -7,12 +7,13 @@
 Build-Depends: cmake,
                cython3,
                debhelper-compat (= 13),
-               dh-python,
+               dh-sequence-python3,
                python3-all-dev,
                python3-astropy <!nocheck>,
                python3-numpy,
                python3-pytest <!nocheck>,
-               python3-setuptools
+               python3-setuptools,
+               python3-setuptools-scm
 Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/sep
 Vcs-Git: https://salsa.debian.org/debian-astro-team/sep.git

## sep 1.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(sep C)

LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_modules/")
include(GNUInstallDirs)

set(SOURCES
   ${CMAKE_SOURCE_DIR}/src/analyse.c
   ${CMAKE_SOURCE_DIR}/src/convolve.c
   ${CMAKE_SOURCE_DIR}/src/deblend.c
   ${CMAKE_SOURCE_DIR}/src/extract.c
   ${CMAKE_SOURCE_DIR}/src/lutz.c
   ${CMAKE_SOURCE_DIR}/src/aperture.c
   ${CMAKE_SOURCE_DIR}/src/background.c
   ${CMAKE_SOURCE_DIR}/src/util.c
   )

include_directories(${CMAKE_INCLUDE_PATH} ${CMAKE_SOURCE_DIR}/src ${CFITSIO_INCLUDE_DIR})

link_directories(${CMAKE_LIBRARY_PATH} ${CMAKE_SOURCE_DIR}/src)

add_library(sep SHARED ${SOURCES})
set_target_properties(sep PROPERTIES OUTPUT_NAME sep)
set_target_properties(sep PROPERTIES VERSION 0.6.0 SOVERSION 0)
set_target_properties(sep PROPERTIES C_VISIBILITY_PRESET hidden)

if (MSVC)
   add_definitions(-D_USE_MATH_DEFINES)
else ()
   add_compile_options(-Wcast-qual)
   target_link_libraries(sep m)
endif()

install(TARGETS sep LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${CMAKE_SOURCE_DIR}/src/sep.h DESTINATION include)

=== Makefile ===
--- 
+++ 
@@ -1,21 +1,41 @@
 
 OS ?= $(shell sh -c 'uname -s | tr "[A-Z]" "[a-z]"')
 
-SOMAJOR = 1
-SOMINOR = 0
-SOBUGFIX = 3
+DESCRIBE           := $(shell git describe --match "v*" --always --tags)
+DESCRIBE_PARTS     := $(subst -, ,$(DESCRIBE))
+
+VERSION_TAG        := $(word 1,$(DESCRIBE_PARTS))
+COMMITS_SINCE_TAG  := $(word 2,$(DESCRIBE_PARTS))
+BUILD_ID           := $(word 3,$(DESCRIBE_PARTS))
+
+VERSION            := $(subst v,,$(VERSION_TAG))
+VERSION_PARTS      := $(subst ., ,$(VERSION))
+
+MAJOR              := $(word 1,$(VERSION_PARTS))
+MINOR              := $(word 2,$(VERSION_PARTS))
+MICRO              := $(word 3,$(VERSION_PARTS))
+
+NEXT_MICRO         := $(shell echo $$(($(MICRO)+1)))
+
+ifeq ($(strip $(COMMITS_SINCE_TAG)),)
+CURRENT_VERSION_MICRO := $(MAJOR).$(MINOR).$(MICRO)
+CURRENT_MICRO := $(MICRO)
+else
+CURRENT_VERSION_MICRO := $(MAJOR).$(MINOR).$(NEXT_MICRO)
+CURRENT_MICRO := $(NEXT_MICRO)-dev$(COMMITS_SINCE_TAG)$(if $(BUILD_ID),-${BUILD_ID},)
+endif
 
 ifeq ($(OS), darwin)
 SONAME = libsep.dylib
-SONAME_MAJOR = libsep.$(SOMAJOR).dylib
-SONAME_FULL = libsep.$(SOMAJOR).$(SOMINOR).$(SOBUGFIX).dylib
+SONAME_MAJOR = libsep.$(MAJOR).dylib
+SONAME_FULL = libsep.$(MAJOR).$(MINOR).$(CURRENT_MICRO).dylib
 SONAME_FLAG = -install_name
 LDPATHENV = DYLD_LIBRARY_PATH
 else
 ifeq ($(OS), linux)
 SONAME = libsep.so
-SONAME_MAJOR = libsep.so.$(SOMAJOR)
-SONAME_FULL = libsep.so.$(SOMAJOR).$(SOMINOR).$(SOBUGFIX)
+SONAME_MAJOR = libsep.so.$(MAJOR)
+SONAME_FULL = libsep.so.$(MAJOR).$(MINOR).$(CURRENT_MICRO)
 SONAME_FLAG = -soname
 LDPATHENV = LD_LIBRARY_PATH
 else
@@ -36,6 +56,7 @@
 
 CPPFLAGS += -Isrc
 CFLAGS += -Wall -Wextra -Wcast-qual -O3 -fvisibility=hidden  # -Werror
+CFLAGS += -DSEP_VERSION_STRING=\"$(MAJOR).$(MINOR).$(CURRENT_MICRO)\"
 CFLAGS_LIB = $(CFLAGS) -fPIC
 LDFLAGS_LIB = $(LDFLAGS) -shared -Wl,$(SONAME_FLAG),$(SONAME_MAJOR)

=== debian/changelog ===
sep (1.4.1-2) unstable; urgency=medium

  * d/watch: update to format version 5.0. Switch to new upstream
  * Push cmake_minimum_required version to 3.10 (Closes: #1113497)
  * Push Standards-Version to 4.7.2, no changes needed
  * Remove Phil Wyett from uploaders list
  * Add missing build depency python3-numpy-dev

 -- Ole Streicher <olebole@debian.org>  Sat, 11 Oct 2025 23:12:29 +0200

sep (1.4.1-1) unstable; urgency=medium

  * Update project homepage
  * New upstream version 1.4.1
  * Skip tests that segfaults on armhf

 -- Ole Streicher <olebole@debian.org>  Sun, 09 Mar 2025 10:36:07 +0100

=== debian/control ===
Source: sep
Standards-Version: 4.7.2
Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders:
 Ole Streicher <olebole@debian.org>,
Section: python
Priority: optional
Build-Depends:
 cmake,
 cython3,
 debhelper-compat (= 13),
 dh-sequence-python3,
 python3-all-dev,
 python3-astropy <!nocheck>,
 python3-numpy,
 python3-numpy-dev,
 python3-pytest <!nocheck>,
 python3-setuptools,
 python3-setuptools-scm,
Vcs-Browser: https://salsa.debian.org/debian-astro-team/sep
Vcs-Git: https://salsa.debian.org/debian-astro-team/sep.git
Homepage: https://github.com/sep-developers/sep
Rules-Requires-Root: no

Package: libsep0
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: C library for source extraction and photometry
 SEP makes the core algorithms of Source Extractor available as a
 library of stand-alone functions and classes. These operate
 directly on in-memory arrays (no FITS files or configuration files).
 The code is derived from the Source Extractor code base (written in
 C) and aims to produce results compatible with Source Extractor
 whenever possible.
 .
 This package contains the shared library.

Package: libsep-dev
Architecture: any
Section: libdevel
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libsep0 (= ${binary:Version}),
Description: C library for source extraction and photometry (development files)
 SEP makes the core algorithms of Source Extractor available as a
 library of stand-alone functions and classes. These operate
 directly on in-memory arrays (no FITS files or configuration files).
 The code is derived from the Source Extractor code base (written in
 C) and aims to produce results compatible with Source Extractor
 whenever possible.

Package: python3-sep
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
 libsep0 (= ${binary:Version}),
Description: Python library for source extraction and photometry
 SEP makes the core algorithms of Source Extractor available as a
 library of stand-alone functions and classes. These operate
 directly on in-memory arrays (no FITS files or configuration files).
 The code is derived from the Source Extractor code base (written in
 C) and aims to produce results compatible with Source Extractor
 whenever possible.
 .
 This Python module that wraps the C library in a Pythonic API. The
 Python wrapper operates on NumPy arrays.

=== debian/tests/control ===
Test-Command: python3 -m pytest test.py
Depends: python3-sep, python3-pytest, python3-astropy

=== debian/watch ===
Version: 5
Template: Github
Owner: sep-developers
Project: sep
